package com.hotwj.platform.config.questionBank.service.impl;

import cn.hutool.core.convert.Convert;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hotwj.platform.config.questionBank.domain.HotQuestionBank;
import com.hotwj.platform.config.questionBank.domain.bo.HotQuestionBankBo;
import com.hotwj.platform.config.questionBank.domain.vo.HotQuestionBankVo;
import com.hotwj.platform.config.questionBank.mapper.HotQuestionBankMapper;
import com.hotwj.platform.config.questionBank.service.IHotQuestionBankService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 题库Service业务层处理
 *
 * @author shihongwei
 * @date 2025-12-23
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class HotQuestionBankServiceImpl implements IHotQuestionBankService {

    private final HotQuestionBankMapper baseMapper;

    /**
     * 查询题库
     *
     * @param id 主键
     * @return 题库
     */
    @Override
    public HotQuestionBankVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询题库列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 题库分页列表
     */
    @Override
    public TableDataInfo<HotQuestionBankVo> queryPageList(HotQuestionBankBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotQuestionBank> lqw = buildQueryWrapper(bo);
        Page<HotQuestionBankVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的题库列表
     *
     * @param bo 查询条件
     * @return 题库列表
     */
    @Override
    public List<HotQuestionBankVo> queryList(HotQuestionBankBo bo) {
        LambdaQueryWrapper<HotQuestionBank> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotQuestionBank> buildQueryWrapper(HotQuestionBankBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<HotQuestionBank> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(HotQuestionBank::getId);
        lqw.in(StringUtils.isNotBlank(bo.getIds()), HotQuestionBank::getId, StringUtils.splitTo(bo.getIds(), Convert::toLong));
//        lqw.eq(bo.getCompanyId() != null, HotQuestionBank::getCompanyId, bo.getCompanyId());
        lqw.eq(bo.getQuestionType() != null, HotQuestionBank::getQuestionType, bo.getQuestionType());
        lqw.eq(StringUtils.isNotBlank(bo.getTrainingTypeCode()), HotQuestionBank::getTrainingTypeCode, bo.getTrainingTypeCode());
        lqw.eq(StringUtils.isNotBlank(bo.getTrainingSubtypeCodes()), HotQuestionBank::getTrainingSubtypeCodes, bo.getTrainingSubtypeCodes());
        lqw.like(StringUtils.isNotBlank(bo.getQuestionDesc()), HotQuestionBank::getQuestionDesc, bo.getQuestionDesc());
        lqw.eq(StringUtils.isNotBlank(bo.getImageUrl()), HotQuestionBank::getImageUrl, bo.getImageUrl());
        lqw.eq(StringUtils.isNotBlank(bo.getOptionA()), HotQuestionBank::getOptionA, bo.getOptionA());
        lqw.eq(StringUtils.isNotBlank(bo.getOptionB()), HotQuestionBank::getOptionB, bo.getOptionB());
        lqw.eq(StringUtils.isNotBlank(bo.getOptionC()), HotQuestionBank::getOptionC, bo.getOptionC());
        lqw.eq(StringUtils.isNotBlank(bo.getOptionD()), HotQuestionBank::getOptionD, bo.getOptionD());
        lqw.eq(StringUtils.isNotBlank(bo.getOptionE()), HotQuestionBank::getOptionE, bo.getOptionE());
        lqw.eq(StringUtils.isNotBlank(bo.getOptionF()), HotQuestionBank::getOptionF, bo.getOptionF());
        lqw.eq(StringUtils.isNotBlank(bo.getCorrectAnswers()), HotQuestionBank::getCorrectAnswers, bo.getCorrectAnswers());
        lqw.eq(bo.getScore() != null, HotQuestionBank::getScore, bo.getScore());
        lqw.eq(bo.getDifficulty() != null, HotQuestionBank::getDifficulty, bo.getDifficulty());
        lqw.eq(StringUtils.isNotBlank(bo.getCaseDesc()), HotQuestionBank::getCaseDesc, bo.getCaseDesc());
        lqw.eq(bo.getStatus() != null, HotQuestionBank::getStatus, bo.getStatus());
        lqw.between(params.get("beginCreateTime") != null && params.get("endCreateTime") != null,
                HotQuestionBank::getCreateTime, params.get("beginCreateTime"), params.get("endCreateTime"));
        return lqw;
    }

    /**
     * 新增题库
     *
     * @param bo 题库
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotQuestionBankBo bo) {
        HotQuestionBank add = MapstructUtils.convert(bo, HotQuestionBank.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改题库
     *
     * @param bo 题库
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotQuestionBankBo bo) {
        HotQuestionBank update = MapstructUtils.convert(bo, HotQuestionBank.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotQuestionBank entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除题库信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
